﻿using System;
using System.Collections.Generic;
using System.Text;
using Jurassic;

namespace $rootnamespace$.PlantillasCodigo
{
    internal class GeneradorJS
    {
        //public static string ObtenerTexto(INodo p_nodo, IDictionary<string, Func<ScriptEngine, object>> p_variables, IDictionary<string, Delegate> p_funciones)
        //{
        //    var v_motor = new ScriptEngine();
        //    v_motor.EnableExposedClrTypes = true;
            
        //    foreach (var v_variable in p_variables)
        //        v_motor.SetGlobalValue(v_variable.Key, v_variable.Value);

        //    foreach (var v_funcion in p_funciones)
        //        v_motor.SetGlobalFunction(v_funcion.Key, v_funcion.Value);

        //    var v_visitante = new Visitante(v_motor);
        //    var v_codigo = string.Format("function __f() {{ _r = \"\\r\"; _n = \"\\n\"; var _s = \"\";\n{0}; return _s; }} __f();", p_nodo.Aceptar(v_visitante));
        //    var v_resultado = v_motor.Evaluate(v_codigo);
        //    return (string)v_resultado;
        //}

        public static string ObtenerTexto(INodo p_nodo, IDictionary<string, Func<ScriptEngine, object>> p_variables, IDictionary<string, Delegate> p_funciones)
        {
            var v_motor = new ScriptEngine();
            v_motor.EnableExposedClrTypes = true;

            foreach (var v_variable in p_variables)
                v_motor.SetGlobalValue(v_variable.Key, v_variable.Value(v_motor));

            foreach (var v_funcion in p_funciones)
                v_motor.SetGlobalFunction(v_funcion.Key, v_funcion.Value);

            var v_visitante = new Visitante(v_motor);
            var v_codigo = string.Format("function __f() {{ _r = \"\\r\"; _n = \"\\n\"; var _s = \"\";\n{0}; return _s; }} __f();", p_nodo.Aceptar(v_visitante));
            var v_resultado = v_motor.Evaluate(v_codigo);
            return (string)v_resultado;
        }

        private class Visitante : IVisitanteNodo<string>
        {
            private ScriptEngine motor;

            public Visitante(ScriptEngine p_motor)
            {
                this.motor = p_motor;
            }

            public string Visitar(NodoVacio nodo)
            {
                return "";
            }

            public string Visitar(NodoTexto nodo)
            {
                var v_texto = nodo.Texto
                    .Replace("\\", "\\\\")
                    .Replace("\"", "\\\"")
                    .Replace("\r", "\" + _r + \"")
                    .Replace("\n", "\" + _n + \"");
                return string.Format("_s += \"{0}\";\n", v_texto);
            }

            public string Visitar(NodoConcatena nodo)
            {
                var v_primero = nodo.Primero.Aceptar(this);
                var v_segundo = nodo.Segundo.Aceptar(this);
                return string.Format("{0}\n{1}", v_primero, v_segundo);
            }

            public string Visitar(NodoExpresion nodo)
            {
                //var v_resultado = Convert.ToString(this.motor.Evaluate(nodo.Expresion))
                //    .Replace("\\", "\\\\")
                //    .Replace("\"", "\\\"")
                //    .Replace("\r", "\" + _r + \"")
                //    .Replace("\n", "\" + _n + \"");
                //return string.Format("_s += \"{0}\";", v_resultado);
                return string.Format("_s += {0}", nodo.Expresion);
            }

            public string Visitar(NodoSentencia nodo)
            {
                return string.Format("{0}\n", nodo.Sentencia);
            }
        }
    }
}
